# -*- coding: UTF-8 -*-
from setuphelpers import *
import json


def update_package():
    """You can do a CTRL F9 in pyscripter to update the package"""
    """ language : any language supported by wapt """
    """ architecture : x32 or x64 """
    import requests, glob

    arch = {"x64": "win64", "x86": "win", "all": "win"}

    proxies = {}
    if isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxies = {"http": proxywapt, "https": proxywapt}

    # Downloading
    lang = control.locale
    # Translating locale
    if "en" in lang:
        lang = "en-US"
    if "es" in lang:
        lang = "es-ES"

    # url = requests.head('https://download.mozilla.org/?product=firefox-esr-latest-ssl&os=%s&lang=%s' % (arch[control.architecture],lang),proxies=proxies).headers['Location']
    # force next
    url = requests.head("https://download.mozilla.org/?product=thunderbird-latest&os=osx&lang=%s" % (lang), proxies=proxies).headers["Location"]

    filename = url.rsplit("/", 1)[1].replace("%20", " ")
    version = filename.split(" ")[-1].split(".dmg")[0]
    datajson = json.loads(wgets("https://product-details.mozilla.org/1.0/thunderbird_versions.json", proxies=proxies))
    version_from_api = datajson.get("THUNDERBIRD_ESR_NEXT", "")
    if not version_from_api:
        version_from_api = datajson["THUNDERBIRD_ESR"]

    url = url.replace(version, version_from_api)
    version = version_from_api.replace('esr','')
    filename = url.rsplit("/", 1)[1].replace("%20", "_")

    for dmg in glob.glob("*.dmg"):
        if dmg != filename:
            remove_file(dmg)

    if not isfile(filename):
        print("Downloading %s from %s" % (filename, url))
        wget(url, filename, proxies=proxies)
    else:
        print(filename + " already exist")

    # Changing version of the package
    control.version = "%s-%s" % (version, "2")
    control.save_control_to_wapt()
    print("Changing version to: %s in WAPT\\control" % control.version)


list_lang = ["fr", "en-US", "es-ES", "de", "it"]
